commit e1edfe597d9157b8b9b61c4677b38730a9a59936
Author: Harald Anlauf <anlauf@gmx.de>
Date:   Wed Jun 24 22:33:11 2020 +0200

    Revert "PR fortran/95689 - ICE in check_sym_interfaces, at fortran/interface.c:2015"
    
    With submodules, name mangling of interfaces may result in long internal
    symbols overflowing an internal buffer.  We now check that we do not
    exceed the enlarged buffer size.
    
    gcc/fortran/
            PR fortran/95689
            * interface.c (check_sym_interfaces): Enlarge temporary buffer,
            and add check on length on mangled name to prevent overflow.
    
    gcc/testsuite/
            PR fortran/95689
            * gfortran.dg/pr95689.f90: New test.
    
            (reverts the cherry-pick from commit 62c0c0ea7bfb6f8f6b8d767b05120cafb6823da6)

diff --git a/gcc/fortran/interface.c b/gcc/fortran/interface.c
index ec8fd3a8f68..689c30210d7 100644
--- a/gcc/fortran/interface.c
+++ b/gcc/fortran/interface.c
@@ -1944,8 +1944,7 @@ check_interface1 (gfc_interface *p, gfc_interface *q0,
 static void
 check_sym_interfaces (gfc_symbol *sym)
 {
-  /* Provide sufficient space to hold "generic interface 'symbol.symbol'".  */
-  char interface_name[2*GFC_MAX_SYMBOL_LEN+2 + sizeof("generic interface ''")];
+  char interface_name[GFC_MAX_SYMBOL_LEN + sizeof("generic interface ''")];
   gfc_interface *p;
 
   if (sym->ns != gfc_current_ns)
@@ -1953,8 +1952,6 @@ check_sym_interfaces (gfc_symbol *sym)
 
   if (sym->generic != NULL)
     {
-      size_t len = strlen (sym->name) + sizeof("generic interface ''");
-      gcc_assert (len < sizeof (interface_name));
       sprintf (interface_name, "generic interface '%s'", sym->name);
       if (check_interface0 (sym->generic, interface_name))
 	return;
